# Written by Ch. Tronche (http://www-ihm.lri.fr/~tronche/)
# Copyright by the author. This is unmaintained, no-warranty free software. 
# Please use freely. It is appreciated (but not mandatory) to acknowledge
# the author's contribution. Thank you.
# Started on Fri Dec 20 17:40:17 1996

package httpDocument;

use integer;
use strict 'refs';

use FileHandle;

sub new {
    local($class, $referer, $_) = @_;
#    warn "new httpDocument(", $referer ? $referer -> url : '<no referer>', ", $_)";
    my ($host, $port, $prefix, $postfix);
    if (/^[a-z]+:/io) {
	s=^http://([^/]*)==io || warn "Trying to get $_ as an HTTP document (referer: ".($referer ? $referer -> url : '<no referer>').')';
	$host = $1;
	$port = $host =~ s/:(\d+)$//o ? $1 : 80;
    } elsif ($referer) {
	$host = $referer -> hostName;
	$port = $referer -> {port};
	my $prefix = $referer -> {'prefix'};
	m=^/=o || s=^=$prefix=o;
	s=/\./=/=o;
    } else {
        s:([^/]*)(?=/)::o;
	die "Can't find a host name in $_" unless $1;
	$host = $1;
	  $port = $host =~ s/:(\d+)$//o ? $1 : 80;
    }
    my $copy = $_;
    while(s=/([^/]*)/\.\./=/=igo) { }
    warn $copy if m=/\.\.=o;
    ($prefix, $postfix) = m:(.*/)([^/]*):o;
    my $bad = '';
    if (!$prefix && !$postfix) {
	$prefix = '/';
    }
    $prefix =~ s/ /%20/go;
    $postfix =~ s/ /%20/go;
#    warn "=== $host:$port=\t$prefix=\t$postfix=\n";
    bless { 'host-name' => $host, 'port' => $port, prefix => $prefix, postfix => $postfix, referer => $referer, bad => $bad, 
	}
}

sub port {
    $_[0] -> {port}
}

sub bad {
    $_[0] -> {bad}
}

sub hostName {
    $_[0] -> {'host-name'}
}

sub url {
    local($self) = @_;
    my $res = $self -> {url};
    if (!$res) {
	$res = "http://".$self -> hostName;
	my $port = $self -> {port};
	$res .= ":$port" if $port;
	$res .= $self -> fileName;
	$self -> {url} = $res;
    }
    $res
}

sub fileName {
    my $self = $_[0];
    $self -> prefix.$self -> {postfix}
}

sub prefix {
    $_[0] -> {'prefix'}
}

1;
